import { Injectable } from '@nestjs/common';
import { BaseDeleteManager } from 'src/core/modules/domain/usecase/managers/base-delete.manager';
import { VipCategoryEntity } from '../../entities/vip-category.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { VipCategoryModel } from '../../../data/models/vip-category.model';
import { VipCategoryDeletedEvent } from '../../entities/event/vip-category-deleted.event';

@Injectable()
export class DeleteVipCategoryManager extends BaseDeleteManager<VipCategoryEntity> {
  getResult(): string {
    return `Success`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return VipCategoryModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: VipCategoryDeletedEvent,
        data: this.data,
      },
    ];
  }
}
